/*
 * Initial main.c file generated by Glade. Edit as required.
 * Glade will not overwrite this file.
 */

#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#define DEFAULT_SOUNDFONT "."
#define DEFAULT_SOUNDFONTPATH "/mnt/dos/sbawe/sfbank"
#define DEFAULT_CHORUS_LEVEL 40
#define DEFAULT_REVERB_LEVEL 60
#define DEFAULT_VALUES 0

#include <gnome.h>
#include <string.h>
#include <errno.h>

#include "interface.h"
#include "support.h"
#include "data.h"
#include "seq.h"
#include "fx.h"

int main (int argc, char *argv[])
{
    FILE *f;
    char tmp[512], *homeenv;
    GtkWidget *pb;

    seq_init();
    load_new_fx_types();

    Preferences.defaultsf = (gchar *) g_malloc(256);
    Preferences.sfpath = (gchar *) g_malloc(256);
    strcpy(Preferences.defaultsf, DEFAULT_SOUNDFONT);
    strcpy(Preferences.sfpath, DEFAULT_SOUNDFONTPATH);
    Preferences.chorus = DEFAULT_CHORUS_LEVEL;
    Preferences.reverb = DEFAULT_REVERB_LEVEL;
    Preferences.values = DEFAULT_VALUES;

    homeenv = getenv("HOME");
    strcpy(tmp, homeenv);
    strcat(tmp, "/.awecp");
    f = fopen(tmp, "rt");
    if (!f)
    {
	/*
	   create file 
	 */
	f = fopen(tmp, "wt");
	if (!f)
	    printf("Error creating \"~/.awecp\"\n");
	else
        {
            fprintf(f,"defaultsf=%s\n",Preferences.defaultsf);
            fprintf(f,"sfpath=%s\n",Preferences.sfpath);
            fprintf(f,"chorus=%d\n",Preferences.chorus);
            fprintf(f,"reverb=%d\n",Preferences.reverb);
            fprintf(f,"values=%d\n",Preferences.values);
	    fclose(f);
	}
    }
    else
    {
	/*
	   load from file 
           */
        while ((!ferror(f)) && (!feof(f)) )
        {
            fscanf(f,"%s\n",&tmp);
            switch(tmp[0])
            {
            case 'd':
                strcpy(Preferences.defaultsf,tmp+10);
                break;
            case 's':
                strcpy(Preferences.sfpath,tmp+7);
                break;
            case 'c':
                Preferences.chorus = atoi(tmp+7);
                break;
            case 'r':
                Preferences.reverb = atoi(tmp+7);
                break;
            case 'v':
                Preferences.values = atoi(tmp+7);
                break;
            }
        }
	fclose(f);
    }

    if (Preferences.chorus<0)
        Preferences.chorus=0;
    else if (Preferences.chorus>100)
        Preferences.chorus=100;
    if (Preferences.reverb<0)
        Preferences.reverb=0;
    else if (Preferences.reverb>100)
        Preferences.reverb=100;
    
    chdir(Preferences.sfpath);
    if (errno!=0)
        printf("Error on chdir(%s)\n",Preferences.sfpath);

    bindtextdomain (PACKAGE, PACKAGE_LOCALE_DIR);
    textdomain (PACKAGE);

    gnome_init ("AWE32ControlPanel", VERSION, argc, argv);

    window1 = create_window1 ();
    gtk_widget_show (window1);
    if (Preferences.values)
    {
	gtk_scale_set_draw_value(GTK_SCALE(lookup_widget(window1, "hscale1")),
				 TRUE);
	gtk_scale_set_draw_value(GTK_SCALE(lookup_widget(window1, "hscale2")),
				 TRUE);
    }
    pb = lookup_widget(window1,"progressbar1");
    gtk_progress_configure(GTK_PROGRESS(pb),
                           seq_mem_avail()/1024.0,0.0,seq_mem_total()/1024.0);

    gtk_main ();

    g_free(Preferences.defaultsf);
    g_free(Preferences.sfpath);
    seq_end();
    return 0;
}

